<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <Toolbar :hasBackButton="true" :pageTitle="$t('admins.page_title')" />
      </q-header>

      <q-page class="pl-fullpage">
        <h4 class="q-my-md">
          {{ $t('admins.page_title') }}
        </h4>

        <div v-if="loading">
          {{ $t('loading') }}
        </div>
        <div v-else>

          <h5 class="q-my-md">
            {{ $t('admins.admin_list_head') }}
          </h5>

          <div v-if="!currentAdmins || Object.keys(currentAdmins).length === 0">
            {{ $t('admins.no_admins') }}
          </div>
          <q-list v-else separator>
            <UserAccount v-for="(user, id) in currentAdmins || {}" :key="id" :user="user" :userId="id"
              :onChange="handleChange" />
          </q-list>

          <h5 class="q-my-md">
            {{ $t('admins.user_list_head') }}
          </h5>

          <div v-if="!currentNormies || Object.keys(currentNormies).length === 0">
            {{ $t('admins.no_users') }}
          </div>
          <q-list separator>
            <UserAccount v-for="(user, id) in currentNormies || {}" :key="id" :user="user" :userId="id"
              :onChange="handleChange" />
          </q-list>
        </div>

      </q-page>
    </q-page-container>
  </q-layout>
</template>
<script>
import { functions, db, } from "../../firebase";
import Toolbar from "../../components/Toolbar.vue";
import UserAccount from "../../components/UserAccount.vue"

export default {
  data()
  {
    return {
      users: undefined,
      changes: {},
      loading: true
    };
  },
  created()
  {
    this.$rtdbBind("users", db.ref('Users')).then(() => this.loading = false);
  },
  computed:
  {
    currentAdmins()
    {
      if (!this.users) return {};
      return Object.fromEntries(Object.entries(this.users).filter(([id, user]) => id && user.IsAdmin));
    },
    currentNormies()
    {
      if (!this.users) return {};
      return Object.fromEntries(Object.entries(this.users).filter(([id, user]) => id && !user.IsAdmin));
    }
  },
  methods:
  {
    handleChange(userId, makeAdmin)
    {

      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t(makeAdmin ? "admins.confirm_add_admin" : "admins.confirm_remove_admin"),
          ok: { label: this.$t("confirm"), flat: true },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          try
          {
            this.$q.loading.show();
            const fbFunction = functions.httpsCallable("updateUserAdminStatus");
            await fbFunction({
              IsAdmin: makeAdmin,
              Id: userId
            });

            this.$q.notify({
              type: 'positive',
              message: this.$t(makeAdmin ? 'admins.added_toast' : 'admins.removed_toast', [this.users[userId].Name])
            })

          } catch (error)
          {
            this.$q.notify({
              type: 'error',
              message: error
            })
          }
          finally
          {
            this.$q.loading.hide();
          }

        });
    },
    async saveChanges()
    {
      try
      {
        this.$q.loading.show();

        for (const trunk in this.changes)
        {
          let newCosts = {};

          for (const code in this.changes[trunk].costs)
          {
            if (this.changes[trunk].costs[code].active)
            {
              newCosts[code] = this.changes[trunk].costs[code].cost;
            }
          }

          const fbFunction = functions.httpsCallable("updateTrunk");
          await fbFunction({
            trunkId: trunk,
            supportedCodes: newCosts,
            capacity: this.changes[trunk].capacity
          });
        }

        this.$q.notify({
          type: 'positive',
          message: this.$t('trunks.save_success')
        })
      }
      catch (error)
      {
        console.log(error);
        this.$q.notify({
          type: 'negative',
          message: error
        })
      }
      this.$q.loading.hide();
    }
  },
  components: {
    Toolbar,
    UserAccount
  },
};
</script>
<style scoped>
.centred {
  margin: 10px auto;
  width: 180px;
}
</style>
    